package cn.com.infosec.crypto.generators;

import cn.com.infosec.crypto.AsymmetricCipherKeyPair;
import cn.com.infosec.crypto.AsymmetricCipherKeyPairGenerator;
import cn.com.infosec.crypto.KeyGenerationParameters;
import cn.com.infosec.crypto.params.DHKeyGenerationParameters;
import cn.com.infosec.crypto.params.DHParameters;
import cn.com.infosec.crypto.params.DHPrivateKeyParameters;
import cn.com.infosec.crypto.params.DHPublicKeyParameters;
import java.math.BigInteger;
import java.security.SecureRandom;

public class DHBasicKeyPairGenerator implements AsymmetricCipherKeyPairGenerator {
   private DHKeyGeneratorHelper helper;
   private DHKeyGenerationParameters param;

   public DHBasicKeyPairGenerator() {
      this.helper = DHKeyGeneratorHelper.INSTANCE;
   }

   public void init(KeyGenerationParameters param) {
      this.param = (DHKeyGenerationParameters)param;
   }

   public AsymmetricCipherKeyPair generateKeyPair() {
      DHBasicKeyPairGenerator var10000 = this;
      DHParameters var1;
      BigInteger var2 = (var1 = this.param.getParameters()).getP();
      DHKeyGeneratorHelper var10001 = this.helper;
      SecureRandom var3 = this.param.getRandom();
      BigInteger var4 = var10001.calculatePrivate(var2, var3, var1.getL());
      var2 = var10000.helper.calculatePublic(var2, var1.getG(), var4);
      return new AsymmetricCipherKeyPair(new DHPublicKeyParameters(var2, var1), new DHPrivateKeyParameters(var4, var1));
   }
}
